#!/usr/bin/perl -wT
# sfb 5 Feb 03
#
use strict;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use File::Temp ':mktemp';

# So we can use the system command
$ENV{PATH} = "/usr/bin:/bin:/opt/bin";

# Global Variables
my $errorDefault = "Web Maple Does not work";
my $errorMsg = $errorDefault;
my $mode = param("pdf");
my $command = param("command");
my $not_there = param("existnot");
my $nullString = "";
my $tmpDir = $nullString;
my $plotIn = $nullString;
my $psOut = $nullString;
my $gifOut = $nullString;
my $pdfOut = $nullString;
my $textOut = $nullString;
my $vrmlOut = $nullString;
my $dxfOut = $nullString;
my $now1 = `/bin/date`;

#if ( $mode ne "draft" ) {
#	$errorMsg = "Only draft mode is working";
#	errorExit();
#}

$tmpDir = mkdtemp("/tmp/webmapleXXXXXX");
$plotIn = $tmpDir .  "/webm";
$psOut = $plotIn . ".ps";
$gifOut = $plotIn . ".gif";
$pdfOut = $plotIn . ".pdf";
$textOut = $plotIn . ".txt";
$vrmlOut = $plotIn . ".wrl";
$dxfOut = $plotIn . ".dxf";
my $status ="0";

makeMapleInput();
if ( $mode eq "vrml" ) {
	badWordsCheck();
	$status = system("/bin/sh -c maple -s -e0 <$plotIn >$textOut 2>&1");
} else {
	$status = system("/bin/sh -c maple -s -e0 -z <$plotIn >$textOut 2>&1");
}
if ( $status ne "0" ) {
	$errorMsg="Maple status error = $status";
	errorExit();
}

if ( $mode eq "pdf" ) {
	pdfOutput();
} elsif ( $mode eq "vrml" ) {
	vrmlOutput();
} elsif ( $mode eq "dxf" ) {
	dxfOutput();
} else {
	gifOutput();
}
textOutput();
$errorMsg = "Past last statement";
errorExit();

sub textOutput() {
	print "Content-type: text/plain\n\n";
	$errorMsg="Cannot open $textOut";
	open(FH, "<$textOut") || die errorExit();
	$errorMsg=$errorDefault;
	while (<FH>) {
		print $_;
	}
	close(FH);
	exit(0);
}

sub vrmlOutput() {
	open(FH, "<$vrmlOut") || textOutput();
	print "Content-type: x-world/x-vrml\n\n";
	while (<FH>) {
		print $_;
	}
	close(FH);
	exit(0);
}

sub dxfOutput() {
	open(FH, "<$dxfOut") || textOutput();
	print "Content-type: vector/x-dxf\n\n";
	while (<FH>) {
		print $_;
	}
	close(FH);
	exit(0);
}

sub gifOutput() {
	open(FH, "<$gifOut") || textOutput();
	print "Content-type: image/gif\n\n";
	while (<FH>) {
		print $_;
	}
	close(FH);
	exit(0);
}

sub pdfOutput() {
	$status = system("/opt/bin/webmaple2pdf $plotIn");
	if ( $status ne "0" ) {
		$errorMsg = "webmaple2pdf returned $status";
		errorExit();
	}
	$errorMsg="Cannot open $pdfOut";
	open(FH, "<$pdfOut") || textOutput();
	$errorMsg=$errorDefault;
	print "Content-type: application/pdf\n\n";
	while (<FH>) {
		print $_;
	}
	close(FH);
	exit(0);
}

### maple input file
sub makeMapleInput() {
	$errorMsg="Cannot open $plotIn";
	open(FH, ">$plotIn") || die errorExit();
	$errorMsg=$errorDefault;
	if ( $mode eq "pdf" ) {
		print FH "plotsetup(cps,plotoutput=`", $psOut,
			"`,plotoptions=`portrait,noborder`);\n";
	} elsif ( $mode eq "dxf" ) {
		print FH "plotsetup(dxf,plotoutput=`", $dxfOut,"`);\n";
	} elsif ( $mode eq "vrml" ) {
		print FH "with(plottools);\n";
	} else {
		print FH "plotsetup(gif,plotoutput=`", $gifOut,
			"`,plotoptions=`width=720,height=540`);\n";
	}
	print FH $command, "\n";
	if ( $mode eq "vrml" ) {
		print FH "vrml(fig3d,`", $vrmlOut, "`);\n";
	}
	close(FH);
}

sub errorExit() {
	print header(), start_html("WebMaple Error");
	print <<HERE;
	<hr>
	<b>Error</b> $errorMsg
	<hr>
	<br> Mode = $mode
	<br> Command
	<pre>
$command
	</pre>
	<br> Existnot = $not_there
	<br> tmpDir = $tmpDir
	<br> plotin = $plotIn
	<br> It is $now1
	<hr>
HERE
	print end_html();
	deleteFiles();
	exit(1);
}

sub deleteFiles() {
	if ( $tmpDir ne $nullString ) {
		system("/bin/rm -rf $tmpDir");
	}
}

my $i;
sub badWordsCheck() {
	foreach $i ("fopen", "!", "read", "save", "mkdir", "currentdir",
		"rmdir", "march", "system", "writeto", "appendto", "fprint") {
		if ( index($command, $i) ne "-1" ) {
			$errorMsg = "Bad word $i";
			errorExit();
		}
	}
}
